#include <bits/stdc++.h>

#include <random>

#define int long long
using namespace std;
int n, k, t;
vector<vector<int>> g;
vector<int> depth, depth1;
vector<int> pred;
map<int, set<int>> z;

void dfs(int v, int p, int d) {
    depth[v] = d;
    pred[v] = p;
    for (int to: g[v]) {
        if (to == p)continue;
        dfs(to, v, d + 1);
    }
}

void upd(int v, int p, int d) {
    z[depth1[v]].erase(v);
    z[d].insert(v);
    for (int to: g[v]) {
        if (to != p) {
            upd(to, v, d + 1);
        }
    }
}

bool check(int d) {
    depth1 = depth;
    z.clear();
    for (int i = 0; i < depth.size(); ++i) {
        z[depth[i]].insert(i);
    }
    int k1 = k;
    while (!z.empty()) {
        if ((--z.end())->second.empty()) {
            z.erase(--z.end());
            continue;
        }
        if ((--z.end())->first <= d) {
            break;
        }
        auto a = (--z.end())->second;
        while (!a.empty()) {
            int v = *a.begin();
            a.erase(v);
            if (depth1[v] <= d)continue;
            for (int i = 0; i < d - 1; ++i) {
                v = pred[v];
            }
            upd(v, pred[v], 1);
            k1--;
        }
    }
    if (k1 >= 0) {
        return true;
    } else {
        return false;
    }
}

void solve() {
    cin >> n >> k >> t;
    g.resize(n);
    depth.resize(n);
    pred.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    if (t == 0) {
        dfs(0, 0, 0);
        int l = 0;
        int r = n;
        while (l + 1 < r) {
            int mid = (l + r) / 2;
            if (check(mid)) {
                r = mid;
            } else {
                l = mid;
            }
        }
        cout << r;
    } else {

    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
    }
    return 0;
}
/*
3 3
1 2 3
2 3 1
3 1 2
8


2 3
2 2 2
2 2 2
5

5 5
1 2 1 4 5
2 5 4 1 2
4 2 4 3 1
5 5 3 2 4
1 2 4 5 2
34
 */
