#include <bits/stdc++.h>

using namespace std;
int n, k, t;
vector<vector<int>> g;
vector<int> depth;
vector<int> pred;
vector<vector<int>> z;
vector<bool> used;
vector<vector<int>> up;

inline void dfs(int v, int p, int d) {
    depth[v] = d;
    pred[v] = p;
    up[v][0] = p;
    for (int i = 1; i < up[v].size(); ++i) {
        up[v][i] = up[up[v][i - 1]][i - 1];
    }
    for (int to: g[v]) {
        if (to == p)continue;
        dfs(to, v, d + 1);
    }
}

inline void upd(int v, int p, int d) {
    used[v] = true;
    for (int to: g[v]) {
        if (to != p && !used[to]) {
            upd(to, v, d + 1);
        }
    }
}

inline bool check(int d) {
    used.assign(n, false);
    z.assign(n, vector<int>(0));
    for (int i = 0; i < depth.size(); ++i) {
        z[depth[i]].push_back(i);
    }
    int k1 = k;
    while (!z.empty()) {
        if (k1 < 0)return false;
        if (z.size() - 1 <= d) {
            return true;
        }
        while (!z.back().empty()) {
            int v = z.back().back();
            z.back().pop_back();
            if (used[v])continue;
            int z1 = d - 1;
            for (int i = up[0].size() - 1; i >= 0; --i) {
                if (z1 >= (1 << i)) {
                    z1 -= (1 << i);
                    v = up[v][i];
                }
            }
            used[v] = true;
            upd(v, pred[v], 1);
            k1--;
            if (k1 < 0)return false;
        }
        z.pop_back();
    }
}

void solve() {
    cin >> n >> k >> t;
    g.resize(n);
    depth.resize(n);
    pred.resize(n);
    bool e = true;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
        if (!(u == i && v == i + 1))e = false;
    }
    if (e) {
        if (t == 0) {
            int l = 0;
            int r = n;
            while (l + 1 < r) {
                int mid = (l + r) / 2;
                if ((n - 2) / mid > k) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            cout << r;
        } else {
            for (int i = 0; i < n; ++i) {
                int l = 0;
                int r = n;
                while (l + 1 < r) {
                    int mid = (l + r) / 2;
                    if (max((int) 0, i - 1) / mid + (n - i - 2) / mid > k) {
                        l = mid;
                    } else {
                        r = mid;
                    }
                }
                cout << r << " ";
            }
        }
        return;
    }
    if (t == 0) {
        up.assign(n, vector<int>(20, 0));
        dfs(0, 0, 0);
        int l = 0;
        int r = n;
        while (l + 1 < r) {
            int mid = (l + r) / 2;
            if (check(mid)) {
                r = mid;
            } else {
                l = mid;
            }
        }
        cout << r;
    } else {
        for (int i = 0; i < n; ++i) {
            up.assign(n, vector<int>(7, i));
            dfs(i, i, 0);
            int l = 0;
            int r = n;
            while (l + 1 < r) {
                int mid = (l + r) / 2;
                if (check(mid)) {
                    r = mid;
                } else {
                    l = mid;
                }
            }
            cout << r << " ";
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
    }
    return 0;
}
/*
5 2 1
1 2
1 3
2 4
2 5
 */