#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
        a[i].second = i;
    }
    vector<int> prime(1e6 + 1, 0);
    vector<int> col(1e6 + 1, 1);
    for (int i = 2; i < 1e6 + 1; ++i) {
        if (prime[i] == 0) {
            prime[i] = i;
            col[i] = 2;
            for (int j = 2; j * i < 1e6 + 1; ++j) {
                prime[i * j] = max(prime[i * j], i);
            }
        } else {
            col[i] = 3 - col[i / prime[i]];
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << col[a[i].first] << " ";
    }
}

signed main() {
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
    }
    return 0;
}