#include <bits/stdc++.h>

#define int long long
using namespace std;
vector<pair<int, int>> g;
vector<int> x;
vector<int> ans;
vector<int> sz;
int id;

void dfs(int v) {
    sz[v] = 1;
    if (x[v] == -1) {
        ans[v] = id;
        id++;
        if (g[v].first != -1) {
            dfs(g[v].first);
            sz[v] += sz[g[v].first];
        }
        if (g[v].second != -1) {
            dfs(g[v].second);
            sz[v] += sz[g[v].second];
        }
    } else if (x[v] == 0) {
        if (g[v].first != -1) {
            dfs(g[v].first);
            sz[v] += sz[g[v].first];
        }
        ans[v] = id;
        id++;
        if (g[v].second != -1) {
            dfs(g[v].second);
            sz[v] += sz[g[v].second];
        }
    } else {
        if (g[v].first != -1) {
            dfs(g[v].first);
            sz[v] += sz[g[v].first];
        }
        if (g[v].second != -1) {
            dfs(g[v].second);
            sz[v] += sz[g[v].second];
        }
        ans[v] = id;
        id++;
    }
}

int siz;
struct node {
    int mod, val;
};
vector<node> tree;
vector<int> p;

void init(int n) {
    siz = 1;
    while (siz < n) {
        siz *= 2;
    }
    tree.assign(2 * siz - 1, {-2, -1});
}

void push(int v, int l, int r) {
    if (r - l == 1 || tree[v].mod == -2)return;
    tree[2 * v + 1].mod = tree[2 * v + 2].mod = tree[2 * v + 1].val = tree[2 * v + 2].val = tree[v].mod;
    tree[v].mod = -2;
}

void upd(int v, int l, int r, int ql, int qr, int val) {
    if (r <= ql || qr <= l)return;
    push(v, l, r);
    if (ql <= l && r <= qr) {
        tree[v].mod = val;
        tree[v].val = val;
        return;
    }
    int mid = (l + r) / 2;
    upd(2 * v + 1, l, mid, ql, qr, val);
    upd(2 * v + 2, mid, r, ql, qr, val);
}

int find_x(int v, int l, int r, int i) {
    push(v, l, r);
    if (r - l == 1) {
        return tree[v].val;
    }
    int mid = (l + r) / 2;
    if (i < mid) {
        return find_x(2 * v + 1, l, mid, i);
    } else {
        return find_x(2 * v + 2, mid, r, i);
    }
}

int find_ans(int i) {
    int an = 0;
    vector<int> z;
    vector<int> id;
    while (true) {
        z.push_back(find_x(0, 0, siz, i));
        id.push_back(i);
        if (i == 0)break;
        i = p[i];
    }
    std::reverse(z.begin(), z.end());
    std::reverse(id.begin(), id.end());
    for (int j = 0; j < z.size(); ++j) {
        if (sz[id[j]] == 1) {
            an++;
        } else {
            if (j + 1 == z.size()) {
                if (z[j] == -1) {
                    an++;
                } else if (z[j] == 0) {
                    an += sz[g[id[j]].first] + 1;
                } else {
                    an += sz[id[j]];
                }
            } else {
                int v = id[j];
                int l = g[v].first;
                int r = g[v].second;
                int nv = id[j + 1];
                if (z[j] == -1) {
                    if (nv == l) {
                        an++;
                    } else {
                        an += 1 + sz[l];
                    }
                } else if (z[j] == 0) {
                    if (nv == l) {
                        continue;
                    } else {
                        an += sz[l] + 1;
                    }
                } else {
                    if (nv == l) {
                        continue;
                    } else {
                        an += sz[l];
                    }
                }
            }
        }
    }
    return an;
}

void solve() {
    int n, q;
    cin >> n >> q;
    x.resize(n, -1);
    g.resize(n, {-1, -1});
    p.resize(n);
    ans.resize(n);
    sz.resize(n);
    map<int, int> cn;
    for (int i = 0; i < n; ++i) {
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        g[i] = {l, r};
        int z = 0;
        if (l != -1) {
            p[l] = i;
            z++;
        }
        if (r != -1) {
            p[r] = i;
            z++;
        }
        cn[z]++;
    }
    if (!cn.count(1) && cn[0] * 2 - 1 == n) {
        dfs(0);
        init(n);
        init(n + 1);
        while (q--) {
            int t;
            cin >> t;
            if (t == 1) {
                int l, r, x1;
                cin >> l >> r >> x1;
                l--;
                upd(0, 0, siz, l, r, x1);
            } else {
                int i;
                cin >> i;
                i--;
                cout << find_ans(i) << '\n';
            }
        }
    } else {
        id = 1;
        dfs(0);
        int cnt = 0;
        init(n + 1);
        while (q--) {
            int t;
            cin >> t;
            if (t == 1) {
                cnt = 1;
                int l, r, x1;
                cin >> l >> r >> x1;
                l--;
                for (int i = l; i < r; ++i) {
                    x[i] = x1;
                }
            } else {
                if (cnt) {
                    id = 1;
                    dfs(0);
                }
                int i;
                cin >> i;
                i--;
                cout << ans[i] << "\n";
                cnt = 0;
            }
        }
    }
}

/*
 5 5
 3 4
 0 0
 5 2
 0 0
 0 0
 2 2
 1 1 3 1
 2 5
 1 3 3 0
 2 3

 */
signed main() {
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
    }
    return 0;
}