#include <bits/stdc++.h>

#include <random>

#define int long long
using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    int s;
    cin >> s;
    vector<int> o(1 << n);
    for (int i = 0; i < o.size(); ++i) {
        o[i] = i;
    }
    std::shuffle(o.begin(), o.end(), std::mt19937(std::random_device()()));
    for (int i = 0; i < (1 << n); ++i) {
        int x = o[i];
        vector<bool> z(n, false);
        int sum = n;
        int id = 0;
        while (x) {
            if (x & 1) {
                z[id] = true;
                sum--;
            }
            id++;
            x >>= 1;
        }
        vector<int> c(m, 0);
        for (int j = 0; j < m; ++j) {
            int sum = 0;
            for (int k = 0; k < n; ++k) {
                if (z[k]) {
                    sum += a[k][j];
                }
            }
            c[j] = sum;
        }
        unordered_map<int, int> dp;
        unordered_map<int, int> pred;
        dp[0] = -1;
        pred[0] = -1;
        for (int j = 0; j < c.size(); ++j) {
            auto ndp = dp;
            for (auto to: ndp) {
                if (to.first + c[j] > s)continue;
                dp[to.first + c[j]] = j;
                pred[to.first + c[j]] = to.first;
            }
        }
        if (dp.count(s)) {
            vector<bool> us(m, false);
            cout << "YES\n";
            int y = s;
            while (y != 0) {
                us[dp[y]] = true;
                y = pred[y];
            }
            for (int j = 0; j < m; ++j) {
                if (!us[j]) {
                    sum++;
                }
            }
            cout << sum << "\n";
            for (int j = 0; j < n; ++j) {
                if (!z[j]) {
                    cout << 1 << " " << j + 1 << "\n";
                }
            }
            for (int j = 0; j < m; ++j) {
                if (!us[j]) {
                    cout << 2 << " " << j + 1 << "\n";
                }
            }
            return;
        }
    }
    cout << "NO";
}

signed main() {
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
    }
    return 0;
}
/*
3 3
1 2 3
2 3 1
3 1 2
8


2 3
2 2 2
2 2 2
5

5 5
1 2 1 4 5
2 5 4 1 2
4 2 4 3 1
5 5 3 2 4
1 2 4 5 2
34
 */
