#include <bits/stdc++.h>

#define int long long
using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n), t(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }
    vector<int> pows(32, 0);
    pows[0] = 2;
    for (int i = 1; i < 32; ++i) {
        pows[i] = pows[i - 1] * 2;
    }
    int l = 0;
    int r = INT_MAX;
    while (l + 1 < r) {
        int mid = (l + r) / 2;
        int sum = 0;
        for (int i = 0; i < n; ++i) {
            if (a[i] + t[i] > mid) {
                if (a[i] <= mid) {
                    sum++;
                }
                continue;
            }
            sum += pows[min(mid - a[i] - t[i], (int) 31)];
        }
        if (sum >= m) {
            r = mid;
        } else {
            l = mid;
        }
    }
    int sum = 0;
    for (int i = 0; i < n; ++i) {
        if (a[i] + t[i] > r) {
            if (a[i] <= r)sum++;
            continue;
        }
        sum += pows[min(r - a[i] - t[i], (int) 31)];
    }
    if (sum == m) {
        cout << r;
    } else {
        cout << -1;
    }
}

/*
4 11
3 5 1 10
2 9 2 13

13 124
5 6 8 8 1 6 4 6 4 7 10 3 9
5 2 10 5 2 1 1 4 8 3 4 1 9
 */
signed main() {
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
    }
    return 0;
}
