#include <bits/stdc++.h>

#define int long long
using namespace std;
const int mod = 1e9 + 7;
map<vector<int>, int> dp;
map<int, int> cnt;
int n, m;

inline int rec(int i, int c1, int c2) {
    if (dp.count({i, c1, c2}))return dp[{i, c1, c2}];
    int newcnt = cnt[i] - c1 - c2;
    if (newcnt < 0)return 0;
    int ans = 0;
    int ost = newcnt % 3;
    for (int j = 0; j <= newcnt / 3; ++j) {
        ans += rec(i - 1, j * 3 + ost, c1);
        ans %= mod;
    }
    dp[{i, c1, c2}] = ans;
    return ans;
}

void solve() {
    cin >> n >> m;
    vector<int> a(n);
    bool e = true;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        if (a[i] % 4 == 0) {
            e = false;
        }
        cnt[a[i]]++;
    }
    if (e) {
        vector<vector<int>> anses;
        for (int i = 1; i < m + 1; i += 4) {
            anses.push_back({cnt[i], cnt[i + 1], cnt[i + 2]});
        }
        vector<int> ans(anses.size());
        for (int i = 0; i < anses.size(); ++i) {
            if (!(anses[i][0] % 3 == anses[i][1] % 3 && anses[i][1] % 3 == anses[i][2] % 3)) {
                ans[i] = 0;
            } else {
                int y = anses[i][0] % 3;
                anses[i][0] -= y;
                anses[i][1] -= y;
                anses[i][2] -= y;
                int mn = min({anses[i][0] / 3, anses[i][1] / 3, anses[i][2] / 3});
                ans[i] = mn + 1;
            }
        }
        int sum = 1;
        for (int i = 0; i < anses.size(); ++i) {
            sum *= ans[i];
            sum %= mod;
        }
        cout << sum;
        return;
    } else if (m <= 4) {
        int sum = 0;
        for (int i = 0; i <= cnt[4] / 3; i++) {
            int c1 = cnt[1], c2 = cnt[2], c3 = cnt[3], c4 = cnt[4] - i * 3;
            if (c2 < c4 || c3 < c4)continue;
            c2 -= c4;
            c3 -= c4;
            if (!(c1 % 3 == c2 % 3 && c2 % 3 == c3 % 3)) {
                continue;
            } else {
                int y = c1 % 3;
                c1 -= y;
                c2 -= y;
                c3 -= y;
                int mn = min({c1 / 3, c2 / 3, c3 / 3});
                sum += mn + 1;
                sum %= mod;
            }
        }
        cout << sum;
        return;
    }
    dp[{0, 0, 0}] = 1;
    cout << rec(m, 0, 0);
}

signed main() {
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
    }
    return 0;
}